=== debian/control ===
Source: alure
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Tobias Hansen <tobias.han@gmx.de>
Build-Depends: debhelper-compat (= 13), cmake, libopenal-dev,
 libvorbis-dev, libflac-dev, libmpg123-dev, libdumb1-dev,
 libmodplug-dev
Rules-Requires-Root: no
Standards-Version: 4.7.0
Section: libs
Vcs-Git: https://salsa.debian.org/games-team/alure.git
Vcs-Browser: https://salsa.debian.org/games-team/alure

Package: libalure-dev
Section: libdevel
Multi-Arch: same
Architecture: any
Depends: libopenal-dev, libalure1 (= ${binary:Version}), ${misc:Depends}
Suggests: alure-doc
Description: AL Utilities REtooled (development files)
 ALURE is a utility library to help manage common tasks with OpenAL
 applications. This includes device enumeration and initialization, file
 loading, and streaming.
 .
 The purpose of this library is to provide pre-made functionality that would
 otherwise be repetitive or difficult to (re)code for various projects and
 platforms, such as loading a sound file into an OpenAL buffer and streaming an
 audio file through a buffer queue. Support for different formats is consistent
 across platforms, so no special checks are needed when loading files, and all
 formats are handled through the same API.
 .
 Currently ALURE includes a basic .wav and .aif file reader, and can leverage
 external libraries such as libSndFile (for extended wave formats and several
 others), VorbisFile (for Ogg Vorbis), and FLAC (for FLAC and Ogg FLAC), and
 others. External libraries can also be dynamically loaded at run-time, or
 individually disabled outright at compile time.
 .
 This package contains the files necessary for development.

Package: libalure1
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: AL Utilities REtooled (shared library)
 ALURE is a utility library to help manage common tasks with OpenAL
 applications. This includes device enumeration and initialization, file
 loading, and streaming.
 .
 The purpose of this library is to provide pre-made functionality that would
 otherwise be repetitive or difficult to (re)code for various projects and
 platforms, such as loading a sound file into an OpenAL buffer and streaming an
 audio file through a buffer queue. Support for different formats is consistent
 across platforms, so no special checks are needed when loading files, and all
 formats are handled through the same API.
 .
 Currently ALURE includes a basic .wav and .aif file reader, and can leverage
 external libraries such as libSndFile (for extended wave formats and several
 others), VorbisFile (for Ogg Vorbis), and FLAC (for FLAC and Ogg FLAC), and
 others. External libraries can also be dynamically loaded at run-time, or
 individually disabled outright at compile time.
 .
 This package installs the ALURE shared library.

Package: alure-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: AL Utilities REtooled (documentation)
 ALURE is a utility library to help manage common tasks with OpenAL
 applications. This includes device enumeration and initialization, file
 loading, and streaming.
 .
 The purpose of this library is to provide pre-made functionality that would
 otherwise be repetitive or difficult to (re)code for various projects and
 platforms, such as loading a sound file into an OpenAL buffer and streaming an
 audio file through a buffer queue. Support for different formats is consistent
 across platforms, so no special checks are needed when loading files, and all
 formats are handled through the same API.
 .
 Currently ALURE includes a basic .wav and .aif file reader, and can leverage
 external libraries such as libSndFile (for extended wave formats and several
 others), VorbisFile (for Ogg Vorbis), and FLAC (for FLAC and Ogg FLAC), and
 others. External libraries can also be dynamically loaded at run-time, or
 individually disabled outright at compile time.
 .
 This package installs the ALURE documentation.

Package: alure-utils
Section: utils
Architecture: any
Depends: libalure1 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Replaces: libalure-dev (<< 1.2-2)
Breaks: libalure-dev (<< 1.2-2)
Description: AL Utilities REtooled (utilities)
 ALURE is a utility library to help manage common tasks with OpenAL
 applications. This includes device enumeration and initialization, file
 loading, and streaming.
 .
 The purpose of this library is to provide pre-made functionality that would
 otherwise be repetitive or difficult to (re)code for various projects and
 platforms, such as loading a sound file into an OpenAL buffer and streaming an
 audio file through a buffer queue. Support for different formats is consistent
 across platforms, so no special checks are needed when loading files, and all
 formats are handled through the same API.
 .
 Currently ALURE includes a basic .wav and .aif file reader, and can leverage
 external libraries such as libSndFile (for extended wave formats and several
 others), VorbisFile (for Ogg Vorbis), and FLAC (for FLAC and Ogg FLAC), and
 others. External libraries can also be dynamically loaded at run-time, or
 individually disabled outright at compile time.
 .
 This package installs the various ALURE utility programs.
