=== debian/watch ===
version=4

opts=uversionmangle=s/\.(tar.*|tgz|zip|gz|bz2)$//i,dversionmangle=s/[-.+~]?(cvs|svn|git|snapshot|pre|hg)(.*)$//i,pasv \
https://kcat.tomasu.net/alure.html alure-releases/alure-?_?([\d+\.]+|\d+)\.tar\.bz2 debian uupdate
